@echo off
rem
rem mk.bat [COMPILER] [debug|release] [tagetname]
rem
setlocal

rem AvƂ̐ݒ.
set TGT=test
set SRCS=test.c
set ERRFILE=err.txt

rem o͖ݒ.
rem set EXENAME=%TGT%.exe
set EXENAME=%TGT%_%COMPILER%.exe


rem ob`̃`FbN.
rem -asm asmname.asm
set GEN_ASM=
if /i "%1"=="-asm" (
  set GEN_ASM=%1
  set SRCS=%2
  shift
  shift
)

if not "%1"=="" (
  set COMPILER=%1
  shift
)
if not "%1"=="" (
  set MOD=%1
  shift
)
if /i "%MOD%"=="DEBUG"   goto SKIP_1
if /i "%MOD%"=="RELEASE" goto SKIP_1
if not "%MOD%"=="" (
  set EXENAME=%MOD%
  set MOD=
)
:SKIP_1
if not "%1"=="" (
  set EXENAME=%1
  shift
)


rem RpCݒ.
if "%COMPILER%"=="" set COMPILER=vc

if /i "%COMPILER%"=="vc"       goto J_VC
if /i "%COMPILER%"=="vc10"     goto J_VC
if /i "%COMPILER%"=="vc32"     goto J_VC
if /i "%COMPILER%"=="vc64"     goto J_VC
if /i "%COMPILER%"=="cl"       goto J_VC
if /i "%COMPILER%"=="gcc"      goto J_GCC
if /i "%COMPILER%"=="g++"      goto J_GCC
if /i "%COMPILER%"=="mingw"    goto J_GCC
if /i "%COMPILER%"=="mingw345" goto J_GCC
if /i "%COMPILER%"=="mingw440" goto J_GCC
if /i "%COMPILER%"=="cygwin"   goto J_GCC
if /i "%COMPILER%"=="llvmgcc"  goto J_GCC
if /i "%COMPILER%"=="borland"  goto J_BCC
if /i "%COMPILER%"=="bcc"      goto J_BCC
if /i "%COMPILER%"=="bc55"     goto J_BCC
if /i "%COMPILER%"=="dm"       goto J_DMC
if /i "%COMPILER%"=="dmc"      goto J_DMC
if /i "%COMPILER%"=="ow"       goto J_WATCOM
if /i "%COMPILER%"=="watcom"   goto J_WATCOM
if /i "%COMPILER%"=="wat"      goto J_WATCOM
if /i "%COMPILER%"=="tinycc"   goto J_TINYCC
if /i "%COMPILER%"=="pcc"      goto J_PCC
if /i "%COMPILER%"=="pocc"     goto J_POCC
if /i "%COMPILER%"=="pellesc"  goto J_POCC
if /i "%COMPILER%"=="lccwin"   goto J_LCCWIN
if /i "%COMPILER%"=="coins"    goto J_COINS
if /i "%COMPILER%"=="clang"    goto J_CLANG
if /i "%COMPILER%"=="clean"    goto J_CLEAN

echo RpCw肳ĂȂ.
goto :EOF

:J_VC
  set CC=cl
  rem set O_CMN=-W4 -wd4127 -wd4996 -wd4244 -GR- -EHac -D_CRT_SECURE_NO_WARNINGS
  set O_CMN=-W4 -wd4127 -wd4996 -wd4244 -GR- -D_CRT_SECURE_NO_WARNINGS
  set O_REL=-Ox -DNDEBUG -MT
  set O_DEB=-ZI -MTd
  set O_OUT=-Fe
  set O_ASM=-FAscu -c 
  set LIBS=
  set ERN=1
  goto COMP

:J_GCC
  set CC=gcc
  rem set O_CMN=-Wall --input-charset=cp932 --exec-charset=cp932 
  set O_CMN=-Wall
  set O_REL=-O2 -DNDEBUG
  set O_DEB=-g
  set O_OUT=-o 
  set O_ASM=-c -S 
  set LIBS=
  set ERN=2
  goto COMP

:J_CLANG
  set CC=clang
  set GCCDIR=c:\msys441\llvm-gcc-4.2
  set O_CMN=-Wall -D_WIN32 -nostdinc "-I %GCCDIR%\include" -I %GCCDIR%\lib\gcc\i386-mingw32\4.2.1\include"
  set O_REL=-O2 -DNDEBUG
  set O_DEB=-g
  set O_OUT=-o 
  set O_ASM=-c -S 
  set LIBS=
  set ERN=2
  goto COMP

:J_BCC
  set CC=bcc32
  set O_CMN=-RT- -d -dc -w -w-8004 -w-8057 -w-8066 -w-8071 -w-8026 -w-8027
  set O_REL=-DNDEBUG -O2 -Ox -RT- -d -dc
  set O_DEB=-v
  set O_OUT=-e
  set O_ASM=-S -c 
  set LIBS=
  set ERN=1
  goto COMP

:J_DMC
  set CC=dmc
  rem set O_CMN=-w -Ae -Ar -j0
  rem set O_CMN=-w -Ae -Ar
  set O_CMN=-w
  set O_REL=-o -DNDEBUG
  set O_DEB=-g
  set O_OUT=-o
  set O_ASM=-cod
  set LIBS=
  set ERN=1
  goto COMP

:J_WATCOM
  set CC=owcc
  rem set O_CMN=-Wall -feh -frtti
  set O_CMN=-Wall
  set O_REL=-Ot -O3 -DNDEBUG -finline-functions -frerun-optimizer -floop-optimize -funroll-loops -finline-math
  set O_DEB=-g3
  set O_OUT=-o 
  set O_ASM=-c
  set LIBS=
  set ERN=1
  goto COMP

:J_TINYCC
  set CC=tcc
  set O_CMN=-Wall
  set O_REL=-DNDEBUG
  set O_DEB=-g
  set O_OUT=-o 
  set O_ASM=-S -c
  set LIBS=
  set ERN=2
  goto COMP

:J_PCC
  set CC=pcc
  set O_CMN=-Wall -D_WIN32
  set O_REL=-O3 -DNDEBUG
  set O_DEB=-g
  set O_OUT=-o 
  set O_ASM=-S -c
  set LIBS=
  set ERN=2
  goto COMP

:J_POCC
  set CC=cc
  set O_CMN=/Zx /Ze /DCLK_TCK=CLOCKS_PER_SEC
  set O_REL=/Ox -DNDEBUG
  set O_DEB=/Zi
  set O_OUT=/o
  set O_ASM=-c
  set LIBS=
  set ERN=1
  goto COMP

:J_LCCWIN
  set CC=lcc
  set O_CMN=-A -xr
  set O_REL=-O -DNDEBUG
  set O_DEB=-g5
  set O_OUT=-Fo
  set O_ASM=-c
  set LIBS=
  set ERN=2
  goto COMP

:J_COINS
  set CC=java -classpath c:/tool/coins/coins-1.4.4.3-en/classes coins.driver.Driver
  set O_CMN=-coins:target=x86-cygwin,assembler=as -DCOINS
  set O_REL=-O2 -DNDEBUG
  set O_DEB=-g
  set O_OUT=-o 
  set O_ASM=-S -c
  set LIBS=
  set ERN=2
  goto COMP

:J_CLEAN
  del *.obj
  del *.tds
  del *.o
  del *.bak
  del *.ncb
  del *.ilk
  del *.suo
  del *.err
  del *.tmp
  del *.map
  del %ERRFILE%
  goto :EOF


rem ۂ̃RpC.
:COMP
if "%MOD%"=="debug" (
  set OPTS=%O_DEB% %O_CMN% %OPTS_ADD%
) else (
  set OPTS=%O_REL% %O_CMN% %OPTS_ADD%
)

if not "%GEN_ASM%"=="" (
  %CC% %OPTS% %O_ASM% %SRCS% %ERN%>%ERRFILE%
  goto :EOF
)

%CC% %OPTS% %O_OUT%%EXENAME% %SRCS% %LIBS% %ERN%>%ERRFILE%
if errorlevel 1 (
  type %ERRFILE%
  pause
) else (
  type %ERRFILE%
)

