/**
 *	@file	pix32_resize.h
 *	@brief	oCjATvOŊgk.
 *	@author	tenk* (Masashi Kitamura)
 *	@note
 *	-	k͕ωf@𕹗p.
 *		x,yTCY𐮐Ŋ悤ɁAU(vZ)Ag傷B
 *		g͐{łȂĂ悢A̓~\B
 *	-	Public Domain Software.
 */

#ifndef PIX32_RESIZE_H
#define PIX32_RESIZE_H

#if !(defined __cplusplus) && !(defined inline) && (defined _WIN32)
#define inline __inline
#endif


#ifndef PIX32_ARGB
/// 8bitla,r,g,bq 32bit ̐Flɂ.
//#define PIX32_ARGB(a,r,g,b)		((((unsigned char)(a))<<24)|(((unsigned char)(r))<<16)|(((unsigned char)(g))<<8)|((unsigned char)(b)))
#define PIX32_ARGB(a,r,g,b)		((((a))<<24)|(((r))<<16)|(((g))<<8)|((b)))		// a,r,g,b\0..255ɂȂĂ邱ƑOɂ.
#endif

#ifndef PIX32_GET_B
/// argbl blue̒l擾.
#define PIX32_GET_B(argb)		((unsigned char)(argb))
#endif

#ifndef PIX32_GET_G
/// argbl green̒l擾.
#define PIX32_GET_G(argb)		((unsigned char)((argb)>>8))
#endif

#ifndef PIX32_GET_R
/// argbl green̒l擾.
#define PIX32_GET_R(argb)		((unsigned char)((argb)>>16))
#endif

#ifndef PIX32_GET_A
/// argbl alpha̒l擾.
#define PIX32_GET_A(argb)		(((unsigned)(argb))>>24)
#endif



/** ŁAk.
 */
static inline void pix32_reducedsizeI(unsigned *dst, unsigned dstW, unsigned dstH, const unsigned *src, unsigned srcW, unsigned srcH)
{
	unsigned 	mw, mh;
	unsigned	msz;
	unsigned 	dx, dy, sxx, syy;
	if (srcW == 0 || srcH == 0 || dstW == 0 || dstH == 0)
		return;
	mw = srcW / dstW;
	mh = srcH / dstH;
	if (mw == 0 || mh == 0)
		return;
	//printf("[%d*%d->(%d,%d)->%d*%d]\n", srcW,srcH,mw,mh,dstW,dstH);
	msz = mw * mh;
	syy = 0;
	for (dy = 0; dy < dstH; ++dy) {
		sxx = 0;
		for (dx = 0; dx < dstW; ++dx) {
			double fa=0, fr=0, fg=0, fb=0;
			unsigned	x, y;
			for (y = syy; y < syy+mh; ++y) {
				for (x = sxx; x < sxx+mw; ++x) {
					unsigned c = src[y*srcW + x];
					fa += PIX32_GET_A(c);
					fr += PIX32_GET_R(c);
					fg += PIX32_GET_G(c);
					fb += PIX32_GET_B(c);
				}
			}
			{
				unsigned ia,ir,ig,ib;
				ia = (unsigned)(fa / msz); if (ia > 254) ia = 255;	// 덷255ɂȂׂ̂254ɂȂ悤ȂŁAē.
				ir = (unsigned)(fr / msz); if (ir > 255) ir = 255;
				ig = (unsigned)(fg / msz); if (ig > 255) ig = 255;
				ib = (unsigned)(fb / msz); if (ib > 255) ib = 255;
				dst[dy * dstW + dx] = PIX32_ARGB(ia,ir,ig,ib);
			}
			sxx += mw;
		}
		syy += mh;
	}
}



/** oCjATvOŊgk.
 */
static inline void pix32_resize(unsigned *dst, unsigned dstW, unsigned dstH, const unsigned *src, unsigned srcW, unsigned srcH)
{
	double rw, rh;

	if (srcW == 0 || srcH == 0 || dstW == 0 || dstH == 0)
		return;

	rw = (double)srcW / dstW;
	rh = (double)srcH / dstH;

	if ((rw >= 1.0) | (rh >= 1.0)) {	// kꍇ.
		if ((srcW % dstW) == 0 && (srcH % dstH) == 0) {
			// łޏꍇ́Ap̏ɂāAoCjAɂ(덷)炷.
			pix32_reducedsizeI(dst, dstW, dstH, src, srcW, srcH);
			return;
		}

		{
			// ck.
			// k{ōs悤ɁAvZr͈UoCjATvOŊg.
			unsigned	msz;
			unsigned	dmw,dmh;
			unsigned 	dx, dy;

			unsigned	mw	= (unsigned)rw + 1;		// ̈ɂ邩.
			unsigned 	mh	= (unsigned)rh + 1;

		  #if 1
			mw += (mw < 2);
			mh += (mh < 2);
		  #endif

			dmw = dstW * mw;		// o͕̐{TCY傫l.
			dmh = dstH * mh;
			rw	= (double)srcW / dmw;
			rh	= (double)srcH / dmh;

			msz = mw   * mh;

			for (dy = 0; dy < dstH; ++dy) {
				for (dx = 0; dx < dstW; ++dx) {
					double fa=0, fr=0, fg=0, fb=0;
					unsigned dmx, dmy ;
					// zIɈUtw*thTCỶ摜Ɋg債,
					// ̒mw*mh sNZPIX32_ARGB̕ςo͂̂PsNZɂ.
					for (dmy = dy*mh; dmy < (dy+1)*mh; ++dmy) {
						for (dmx = dx*mw; dmx < (dx+1)*mw; ++dmx) {
							double	sx = dmx * rw - 0.5;
							double	sy = dmy * rh - 0.5;
							if (sx < 0)
								sx = 0;
							if (sy < 0)
								sy = 0;
							{
								unsigned	x0 = (unsigned)sx;
								unsigned	y0 = (unsigned)sy;
								double		kw = sx - x0;
								double		kh = sy - y0;
								double		k0 = (1.0 - kw) * (1.0 - kh);
								double		k1 = kw * (1.0 - kh);
								double		k2 = (1.0 - kw) * kh;
								double		k3 = kw * kh;
								unsigned	ccX0a1lW = (x0+1 < srcW);
								unsigned	ccY0a1lH = (y0+1 < srcH);
								unsigned	c0	= src[y0 * srcW + x0];
								unsigned	c1	= ccX0a1lW ? src[y0 * srcW + x0 + 1] : c0;
								unsigned	c2	= ccY0a1lH ? src[(y0+1) * srcW + x0] : c0;
								unsigned	c3	=(ccX0a1lW & ccY0a1lH) ? src[(y0+1) * srcW + (x0 + 1)]
												: ccX0a1lW			   ? c1
												: ccY0a1lH			   ? c2
												:						 c0;
								fa += (PIX32_GET_A(c0)*k0 + PIX32_GET_A(c1)*k1 + PIX32_GET_A(c2)*k2 + PIX32_GET_A(c3)*k3);
								fr += (PIX32_GET_R(c0)*k0 + PIX32_GET_R(c1)*k1 + PIX32_GET_R(c2)*k2 + PIX32_GET_R(c3)*k3);
								fg += (PIX32_GET_G(c0)*k0 + PIX32_GET_G(c1)*k1 + PIX32_GET_G(c2)*k2 + PIX32_GET_G(c3)*k3);
								fb += (PIX32_GET_B(c0)*k0 + PIX32_GET_B(c1)*k1 + PIX32_GET_B(c2)*k2 + PIX32_GET_B(c3)*k3);
							}
						}
					}
					{
						unsigned ia,ir,ig,ib;
						ia = (unsigned)(fa / msz); if (ia > 254) ia = 255;	// 덷255ɂȂׂ̂254ɂȂ悤ȂŁAē.
						ir = (unsigned)(fr / msz); if (ir > 255) ir = 255;
						ig = (unsigned)(fg / msz); if (ig > 255) ig = 255;
						ib = (unsigned)(fb / msz); if (ib > 255) ib = 255;
						dst[dy * dstW + dx] = PIX32_ARGB(ia,ir,ig,ib);
					}
				}
			}
		}
	}
  #if 1
	else {	//g又 k̏ŁAgȂA₷Ƒx?̂߂ɁÃ[`͎c.
		unsigned dx,dy;
		for (dy = 0; dy < dstH; dy++) {
			for (dx = 0; dx < dstW; dx++) {
				double	sx = dx * rw - 0.5;
				double	sy = dy * rh - 0.5;
				if (sx < 0)
					sx = 0;
				if (sy < 0)
					sy = 0;
				{
					unsigned	x0 = (unsigned)(sx-0.0);
					unsigned	y0 = (unsigned)(sy-0.0);
					double 		kw = sx - x0;
					double 		kh = sy - y0;
					double 		k0 = (1.0 - kw) * (1.0 - kh);
					double 		k1 = kw * (1.0 - kh);
					double 		k2 = (1.0 - kw) * kh;
					double 		k3 = kw * kh;
					unsigned	ccX0a1lW = x0+1 < srcW;
					unsigned	ccY0a1lH = y0+1 < srcH;
					unsigned	c0 = src[y0 * srcW + x0];
					unsigned	c1 = ccX0a1lW ? src[y0 * srcW + x0 + 1] : c0;
					unsigned	c2 = ccY0a1lH ? src[(y0+1) * srcW + x0] : c0;
					unsigned	c3 = (ccX0a1lW & ccY0a1lH) ? src[(y0+1) * srcW + x0 + 1]
								   : ccX0a1lW ? 			 c1
								   : ccY0a1lH ? 			 c2
								   :						 c0;
					unsigned	ir = (unsigned)( (PIX32_GET_R(c0)*k0 + PIX32_GET_R(c1)*k1 + PIX32_GET_R(c2)*k2 + PIX32_GET_R(c3)*k3) );
					unsigned	ig = (unsigned)( (PIX32_GET_G(c0)*k0 + PIX32_GET_G(c1)*k1 + PIX32_GET_G(c2)*k2 + PIX32_GET_G(c3)*k3) );
					unsigned	ib = (unsigned)( (PIX32_GET_B(c0)*k0 + PIX32_GET_B(c1)*k1 + PIX32_GET_B(c2)*k2 + PIX32_GET_B(c3)*k3) );
					unsigned	ia = (unsigned)( (PIX32_GET_A(c0)*k0 + PIX32_GET_A(c1)*k1 + PIX32_GET_A(c2)*k2 + PIX32_GET_A(c3)*k3) );

					if (ia > 254) ia = 255;	// 덷255ɂȂׂ̂254ɂȂ悤ȂŁAē.
					if (ir > 255) ir = 255;
					if (ig > 255) ig = 255;
					if (ib > 255) ib = 255;

					dst[dy * dstW + dx] = PIX32_ARGB(ia,ir,ig,ib);
				}
			}
		}
	}
  #endif
}


#endif
