/**
 *	@file	test.cpp
 *	@brief
 *	@author	tenk*
 *	@date	2010-??
 *	@note
 */

#include <stdio.h>
//#include <stdlib.h>

#include "pix32_resize.h"


// ===========================================================================

static unsigned 	XorShiftRand_seed_[2];

void XorShiftRand64_init(unsigned s) {
	XorShiftRand_seed_[0] = s = 1812433253U * (s ^ (s>>30)) + 1;
	XorShiftRand_seed_[1]	  = 1812433253U * (s ^ (s>>30)) + 2;
}

unsigned XorShiftRand64(void) {
	enum { A =10, B =13, C =10 };		// [10,13,10][8,9,22][2,7,3][23,3,24]
	unsigned  t, y;
	unsigned* a = XorShiftRand_seed_;
	t	 = a[0];
	t	 = (t ^ (t<<A));
	a[0] = y = a[1];
	t	 = (y ^ (y>>C)) ^ (t ^ (t>>B));
	a[1] = t;
	return t;
}



// ===========================================================================
unsigned test_buf [  640 * 480	];
unsigned test_buf2[ 1920 * 1080 ];
unsigned test_dmy_counter = 0;

static void test_init1(void) {
	unsigned x, y;

	XorShiftRand64_init(0);
	for (y = 0; y < 480; ++y) {
		for (x = 0; x < 640; ++x) {
			test_buf[y * 640 + x] = XorShiftRand64();
		}
	}
}

static void test_1(void) {
	pix32_resize(test_buf2, 1920, 1080, test_buf, 640, 480);
}



// ===========================================================================
// Ԍv֌W
#ifndef PERFCNT_TICK_T
#if 0 //def _WIN32
#include <windows.h>
typedef unsigned __int64 	PERFCNT_TICK_T;
static inline PERFCNT_TICK_T		PERFCNT_getTick()	 { PERFCNT_TICK_T c; QueryPerformanceCounter((LARGE_INTEGER*)&c); return c; }
static inline PERFCNT_TICK_T		PERFCNT_tickPerSec() { static PERFCNT_TICK_T s = 0; if (!s) QueryPerformanceFrequency((LARGE_INTEGER*)&s); return s;  }
#elif 0 //defined LINUX
#include <sys/resource.h>
typedef  unsigned long long	PERFCNT_TICK_T;
static inline PERFCNT_TICK_T 		PERFCNT_getTick() 	{ struct rusage t; getrusage(RUSAGE_SELF, &t); return t.ru_utime.tv_sec * 1000000ULL + t.ru_utime.tv_usec; }
#define 					PERFCNT_tickPerSec() 	1000000ULL
#else
#include <time.h>
typedef clock_t 				PERFCNT_TICK_T;
#define PERFCNT_getTick() 		clock()
#define PERFCNT_tickPerSec() 	CLOCKS_PER_SEC
#endif
#endif



// ===========================================================================
// v`FbN

typedef void (*test_func_t)();


static double benchmark(test_func_t test, size_t count, unsigned flags, const char* ttl)
{
	PERFCNT_TICK_T	start_tick;
	PERFCNT_TICK_T	elapsed;
	unsigned		j;
	double			e;
	unsigned char	verboss		= (unsigned char)(flags & 1);
	if (verboss) {
		printf("\t%s:start\n", ttl);
	}
	start_tick	= PERFCNT_getTick();				// vJn
	for (j = 0; j < count; ++j) {
		test();
	}
	elapsed	  = PERFCNT_getTick() - start_tick;		// vI
	e		  = elapsed * 1.0 / (PERFCNT_tickPerSec() * count);
	if (verboss) {
		printf("\t%s:end (%f)\n", ttl, e * 1000000.0);
	}

	for (j = 0; j < 1920*1080; ++j) {
		test_dmy_counter += test_buf2[j];
	}
	return e;	// vꂽ.
}




static void test_all(unsigned count, unsigned flags, const char* name)
{
	enum { N = 64 };
	const char*	nm[N]		= {0};
	double		elaped[N]	= { 0 };
	unsigned	j;

	if (name == 0)
		printf("\neXgv(%9ds̕) (~b)\n", count );
	name = (name) ? name : "test";

	test_init1();

	// ̃eXgĂяo.
	{
		unsigned k 	   = 0;
		nm[k] = name		; elaped[k] = benchmark(test_1, count, flags, nm[k]); ++k;
	//	nm[k] = "test 2"	; elaped[k] = benchmark(test_2, count, flags, nm[k]); ++k;
	}

	for (j = 0; j < N; ++j) {
		double	e;
		if (nm[j] == 0)
			continue;
		printf(",%-21s ,", nm[j]);
		e = elaped[j] * 1000.0;
		if (e > 0)
			printf("%12.3f,", e);
		else
			printf("%12s,", "---");
		printf("\n");
	}
	printf("// œK̈ӖȂo %d\n", test_dmy_counter);
}



// ===========================================================================

/** g.
 */
static int usage()
{
	printf( "usage>test [-opts] file(s)\n"
		   "  eXg[`.\n"
		   "  -cN   s񐔂̎w\n"
		   "  -v    o߃bZ[W𑝂₷\n"
		  );
	return 1;
}



/** C.
 */
int main(int argc, const char* argv[])
{
	int		 	i;
	unsigned 	count = 1;
	unsigned 	flags = 0;
	const char* name  = NULL;

	if (argc < 2)
		return usage();

	// IvV擾.
	for (i = 1; i < argc; ++i) {
		const char* a = argv[i];
		if (a[0] == '-') {
			if (a[1] == 'v') {
				flags = 1;		// verboss;
			} else if (a[1] == 'c') {
				count	= strtol(a+2,0,0);
				if (count < 1)
					count = 1;
			} else if (a[1] == 't') {
				name = a+2;
			} else {
				return usage();
			}
		}
	}

	test_all(count, flags, name);

	return 0;
}
