/* Provide Declarations */
#include <stdarg.h>
#include <setjmp.h>
/* get a declaration for alloca */
#if defined(__CYGWIN__) || defined(__MINGW32__)
#define  alloca(x) __builtin_alloca((x))
#define _alloca(x) __builtin_alloca((x))
#elif defined(__APPLE__)
extern void *__builtin_alloca(unsigned long);
#define alloca(x) __builtin_alloca(x)
#define longjmp _longjmp
#define setjmp _setjmp
#elif defined(__sun__)
#if defined(__sparcv9)
extern void *__builtin_alloca(unsigned long);
#else
extern void *__builtin_alloca(unsigned int);
#endif
#define alloca(x) __builtin_alloca(x)
#elif defined(__FreeBSD__) || defined(__NetBSD__) || defined(__OpenBSD__) || defined(__DragonFly__) || defined(__arm__)
#define alloca(x) __builtin_alloca(x)
#elif defined(_MSC_VER)
#define inline _inline
#define alloca(x) _alloca(x)
#else
#include <alloca.h>
#endif

#ifndef __GNUC__  /* Can only support "linkonce" vars with GCC */
#define __attribute__(X)
#endif

#if defined(__GNUC__) && defined(__APPLE_CC__)
#define __EXTERNAL_WEAK__ __attribute__((weak_import))
#elif defined(__GNUC__)
#define __EXTERNAL_WEAK__ __attribute__((weak))
#else
#define __EXTERNAL_WEAK__
#endif

#if defined(__GNUC__) && defined(__APPLE_CC__)
#define __ATTRIBUTE_WEAK__
#elif defined(__GNUC__)
#define __ATTRIBUTE_WEAK__ __attribute__((weak))
#else
#define __ATTRIBUTE_WEAK__
#endif

#if defined(__GNUC__)
#define __HIDDEN__ __attribute__((visibility("hidden")))
#endif

#ifdef __GNUC__
#define LLVM_NAN(NanStr)   __builtin_nan(NanStr)   /* Double */
#define LLVM_NANF(NanStr)  __builtin_nanf(NanStr)  /* Float */
#define LLVM_NANS(NanStr)  __builtin_nans(NanStr)  /* Double */
#define LLVM_NANSF(NanStr) __builtin_nansf(NanStr) /* Float */
#define LLVM_INF           __builtin_inf()         /* Double */
#define LLVM_INFF          __builtin_inff()        /* Float */
#define LLVM_PREFETCH(addr,rw,locality) __builtin_prefetch(addr,rw,locality)
#define __ATTRIBUTE_CTOR__ __attribute__((constructor))
#define __ATTRIBUTE_DTOR__ __attribute__((destructor))
#define LLVM_ASM           __asm__
#else
#define LLVM_NAN(NanStr)   ((double)0.0)           /* Double */
#define LLVM_NANF(NanStr)  0.0F                    /* Float */
#define LLVM_NANS(NanStr)  ((double)0.0)           /* Double */
#define LLVM_NANSF(NanStr) 0.0F                    /* Float */
#define LLVM_INF           ((double)0.0)           /* Double */
#define LLVM_INFF          0.0F                    /* Float */
#define LLVM_PREFETCH(addr,rw,locality)            /* PREFETCH */
#define __ATTRIBUTE_CTOR__
#define __ATTRIBUTE_DTOR__
#define LLVM_ASM(X)
#endif

#if __GNUC__ < 4 /* Old GCC's, or compilers not GCC */ 
#define __builtin_stack_save() 0   /* not implemented */
#define __builtin_stack_restore(X) /* noop */
#endif

#if __GNUC__ && __LP64__ /* 128-bit integer types */
typedef int __attribute__((mode(TI))) llvmInt128;
typedef unsigned __attribute__((mode(TI))) llvmUInt128;
#endif

#define CODE_FOR_MAIN() /* Any target-specific code for main()*/

#ifndef __cplusplus
typedef unsigned char bool;
#endif


/* Support for floating point constants */
typedef unsigned long long ConstantDoubleTy;
typedef unsigned int        ConstantFloatTy;
typedef struct { unsigned long long f1; unsigned short f2; unsigned short pad[3]; } ConstantFP80Ty;
typedef struct { unsigned long long f1; unsigned long long f2; } ConstantFP128Ty;


/* Global Declarations */
/* Helper union for bitcasts */
typedef union {
  unsigned int Int32;
  unsigned long long Int64;
  float Float;
  double Double;
} llvmBitCastUnion;
/* Structure forward decls */
struct l_unnamed0;
struct l_unnamed1;
struct l_unnamed10;
struct l_unnamed11;
struct l_unnamed12;
struct l_unnamed13;
struct l_unnamed2;
struct l_unnamed3;
struct l_unnamed4;
struct l_unnamed5;
struct l_unnamed6;
struct l_unnamed7;
struct l_unnamed8;
struct l_unnamed9;

/* Typedefs */
typedef struct l_unnamed0 l_unnamed0;
typedef struct l_unnamed1 l_unnamed1;
typedef struct l_unnamed10 l_unnamed10;
typedef struct l_unnamed11 l_unnamed11;
typedef struct l_unnamed12 l_unnamed12;
typedef struct l_unnamed13 l_unnamed13;
typedef struct l_unnamed2 l_unnamed2;
typedef struct l_unnamed3 l_unnamed3;
typedef struct l_unnamed4 l_unnamed4;
typedef struct l_unnamed5 l_unnamed5;
typedef struct l_unnamed6 l_unnamed6;
typedef struct l_unnamed7 l_unnamed7;
typedef struct l_unnamed8 l_unnamed8;
typedef struct l_unnamed9 l_unnamed9;

/* Structure contents */
struct l_unnamed0 { unsigned char array[9]; };

struct l_unnamed1 { unsigned char array[8]; };

struct l_unnamed10 { unsigned int array[2073600]; };

struct l_unnamed11 { unsigned int array[307200]; };

struct l_unnamed12 { double array[64]; };

struct l_unnamed13 { unsigned char *array[64]; };

struct l_unnamed2 { unsigned char array[5]; };

struct l_unnamed3 { unsigned char array[6]; };

struct l_unnamed4 { unsigned char array[39]; };

struct l_unnamed5 { unsigned char array[4]; };

struct l_unnamed6 { unsigned char array[14]; };

struct l_unnamed7 { unsigned char array[32]; };

struct l_unnamed8 { unsigned char array[11]; };

struct l_unnamed9 { unsigned char array[99]; };


/* External Global Variable Declarations */
extern struct l_unnamed11 test_buf;
extern struct l_unnamed10 test_buf2;
extern unsigned int test_dmy_counter;

/* Function Declarations */
double fmod(double, double);
float fmodf(float, float);
long double fmodl(long double, long double);
void XorShiftRand64_init(unsigned int llvm_cbe_s);
unsigned int XorShiftRand64(void);
static void test_1(void);
unsigned int puts(unsigned char *);
unsigned int printf(unsigned char *, ...);
unsigned int clock(void);
unsigned int putchar(unsigned int );
unsigned int main(unsigned int llvm_cbe_argc, unsigned char **llvm_cbe_argv);
unsigned int strtol();
unsigned char *malloc();
void free(unsigned char *);
void abort(void);
unsigned char *memset(unsigned char *, unsigned int , unsigned int );


/* Global Variable Declarations */
static unsigned int XorShiftRand_seed__2E_0;
static unsigned int XorShiftRand_seed__2E_1;
extern struct l_unnamed11 test_buf __ATTRIBUTE_WEAK__;
extern struct l_unnamed10 test_buf2 __ATTRIBUTE_WEAK__;
static struct l_unnamed9 _2E_str;
static struct l_unnamed8 _2E_str1;
static struct l_unnamed6 _2E_str2;
extern unsigned int test_dmy_counter;
static struct l_unnamed4 _2E_str3;
static struct l_unnamed2 _2E_str4;
static struct l_unnamed0 _2E_str5;
static struct l_unnamed1 _2E_str6;
static struct l_unnamed3 _2E_str7;
static struct l_unnamed5 _2E_str8;
static struct l_unnamed7 _2E_str9;


/* Global Variable Definitions and Initialization */
static unsigned int XorShiftRand_seed__2E_0;
static unsigned int XorShiftRand_seed__2E_1;
struct l_unnamed11 test_buf __ATTRIBUTE_WEAK__;
struct l_unnamed10 test_buf2 __ATTRIBUTE_WEAK__;
static struct l_unnamed9 _2E_str = { "usage>test [-opts] file(s)\n  \x83\x65\x83X\x83g\x83\x8B\x81[\x83`\x83\x93.\n  -cN   \x8E\x8E\x8Ds\x89\xF1\x90\x94\x82\xCC\x8Ew\x92\xE8\n  -v    \x8Co\x89\xDF\x83\x81\x83\x62\x83Z\x81[\x83W\x82\xF0\x91\x9D\x82\xE2\x82\xB7" };
static struct l_unnamed8 _2E_str1 = { "\t%s:start\n" };
static struct l_unnamed6 _2E_str2 = { "\t%s:end (%f)\n" };
unsigned int test_dmy_counter;
static struct l_unnamed4 _2E_str3 = { "\n\x83\x65\x83X\x83g\x8Cv\x91\xAA(%9d\x89\xF1\x8E\xC0\x8Ds\x82\xCC\x95\xBD\x8B\xCF) (\x83~\x83\x8A\x95\x62)\n" };
static struct l_unnamed2 _2E_str4 = { "test" };
static struct l_unnamed0 _2E_str5 = { ",%-21s ," };
static struct l_unnamed1 _2E_str6 = { "%12.3f," };
static struct l_unnamed3 _2E_str7 = { "%12s," };
static struct l_unnamed5 _2E_str8 = { "---" };
static struct l_unnamed7 _2E_str9 = { "// \x8D\xC5\x93K\x89\xBB\x89\xF1\x94\xF0\x82\xCC\x88\xD3\x96\xA1\x82\xC8\x82\xB5\x8Fo\x97\xCD %d\n" };


/* Function Bodies */
static inline int llvm_fcmp_ord(double X, double Y) { return X == X && Y == Y; }
static inline int llvm_fcmp_uno(double X, double Y) { return X != X || Y != Y; }
static inline int llvm_fcmp_ueq(double X, double Y) { return X == Y || llvm_fcmp_uno(X, Y); }
static inline int llvm_fcmp_une(double X, double Y) { return X != Y; }
static inline int llvm_fcmp_ult(double X, double Y) { return X <  Y || llvm_fcmp_uno(X, Y); }
static inline int llvm_fcmp_ugt(double X, double Y) { return X >  Y || llvm_fcmp_uno(X, Y); }
static inline int llvm_fcmp_ule(double X, double Y) { return X <= Y || llvm_fcmp_uno(X, Y); }
static inline int llvm_fcmp_uge(double X, double Y) { return X >= Y || llvm_fcmp_uno(X, Y); }
static inline int llvm_fcmp_oeq(double X, double Y) { return X == Y ; }
static inline int llvm_fcmp_one(double X, double Y) { return X != Y && llvm_fcmp_ord(X, Y); }
static inline int llvm_fcmp_olt(double X, double Y) { return X <  Y ; }
static inline int llvm_fcmp_ogt(double X, double Y) { return X >  Y ; }
static inline int llvm_fcmp_ole(double X, double Y) { return X <= Y ; }
static inline int llvm_fcmp_oge(double X, double Y) { return X >= Y ; }

void XorShiftRand64_init(unsigned int llvm_cbe_s) {
  unsigned int llvm_cbe_tmp__1;

  llvm_cbe_tmp__1 = ((unsigned int )(((unsigned int )(((unsigned int )(((unsigned int )((((unsigned int )(((unsigned int )llvm_cbe_s) >> ((unsigned int )30u)))) ^ llvm_cbe_s)) * ((unsigned int )1812433253u))))) + ((unsigned int )1u)));
  *(&XorShiftRand_seed__2E_0) = llvm_cbe_tmp__1;
  *(&XorShiftRand_seed__2E_1) = (((unsigned int )(((unsigned int )(((unsigned int )(((unsigned int )((((unsigned int )(((unsigned int )llvm_cbe_tmp__1) >> ((unsigned int )30u)))) ^ llvm_cbe_tmp__1)) * ((unsigned int )1812433253u))))) + ((unsigned int )2u))));
  return;
}


unsigned int XorShiftRand64(void) {
  unsigned int llvm_cbe_tmp__2;
  unsigned int llvm_cbe_tmp__3;
  unsigned int llvm_cbe_tmp__4;
  unsigned int llvm_cbe_tmp__5;

  llvm_cbe_tmp__2 = *(&XorShiftRand_seed__2E_0);
  llvm_cbe_tmp__3 = (llvm_cbe_tmp__2 << 10u) ^ llvm_cbe_tmp__2;
  llvm_cbe_tmp__4 = *(&XorShiftRand_seed__2E_1);
  *(&XorShiftRand_seed__2E_0) = llvm_cbe_tmp__4;
  llvm_cbe_tmp__5 = ((llvm_cbe_tmp__3 ^ llvm_cbe_tmp__4) ^ (((unsigned int )(((unsigned int )llvm_cbe_tmp__4) >> ((unsigned int )10u))))) ^ (((unsigned int )(((unsigned int )llvm_cbe_tmp__3) >> ((unsigned int )13u))));
  *(&XorShiftRand_seed__2E_1) = llvm_cbe_tmp__5;
  return llvm_cbe_tmp__5;
}

static const ConstantDoubleTy FPConstant0 = 0x3FD5555555555555ULL;    /* 3.333333e-001 */
static const ConstantDoubleTy FPConstant1 = 0x3FDC71C71C71C71CULL;    /* 4.444444e-001 */

static void test_1(void) {
  unsigned int llvm_cbe_tmp__6;
  unsigned int llvm_cbe_tmp__6__PHI_TEMPORARY;
  unsigned int *llvm_cbe_scevgep_2e_i;
  double llvm_cbe_tmp__7;
  double llvm_cbe_sx_2e_0_2e_i;
  unsigned int llvm_cbe_tmp__8;
  double llvm_cbe_tmp__9;
  double llvm_cbe_tmp__10;
  double llvm_cbe_tmp__11;
  double llvm_cbe_tmp__12;
  double llvm_cbe_tmp__13;
  double llvm_cbe_tmp__14;
  unsigned int llvm_cbe_tmp__15;
  unsigned int llvm_cbe_tmp__16;
  unsigned int llvm_cbe_iftmp_2e_9_2e_0_2e_i;
  unsigned int llvm_cbe_iftmp_2e_9_2e_0_2e_i__PHI_TEMPORARY;
  unsigned int llvm_cbe_tmp__17;
  unsigned int llvm_cbe_iftmp_2e_10_2e_0_2e_i;
  unsigned int llvm_cbe_iftmp_2e_10_2e_0_2e_i__PHI_TEMPORARY;
  unsigned int llvm_cbe_tmp__18;
  unsigned int llvm_cbe_iftmp_2e_13_2e_0_2e_i;
  unsigned int llvm_cbe_iftmp_2e_11_2e_0_2e_i;
  unsigned int llvm_cbe_iftmp_2e_11_2e_0_2e_i__PHI_TEMPORARY;
  unsigned int llvm_cbe_tmp__19;
  unsigned int llvm_cbe_tmp__20;
  unsigned int llvm_cbe_tmp__21;
  unsigned int llvm_cbe_tmp__22;
  unsigned int llvm_cbe_tmp__23;
  unsigned int llvm_cbe_tmp__24;
  unsigned int llvm_cbe_tmp__25;
  unsigned int llvm_cbe_tmp__25__PHI_TEMPORARY;
  unsigned int llvm_cbe_tmp;
  double llvm_cbe_tmp__26;
  double llvm_cbe_sy_2e_0_2e_i;
  unsigned int llvm_cbe_tmp__27;
  double llvm_cbe_tmp__28;
  double llvm_cbe_tmp__29;
  unsigned int llvm_cbe_tmp__30;
  unsigned int llvm_cbe_tmp__31;
  unsigned int llvm_cbe_tmp__32;
  unsigned int llvm_cbe_tmp__33;

  llvm_cbe_tmp__25__PHI_TEMPORARY = 0u;   /* for PHI node */
  goto llvm_cbe_bb104_2e_preheader_2e_i;

  do {     /* Syntactic loop 'bb104.preheader.i' to make GCC happy */
llvm_cbe_bb104_2e_preheader_2e_i:
  llvm_cbe_tmp__25 = llvm_cbe_tmp__25__PHI_TEMPORARY;
  llvm_cbe_tmp = ((unsigned int )(((unsigned int )llvm_cbe_tmp__25) * ((unsigned int )1920u)));
  llvm_cbe_tmp__26 = ((((double )(unsigned int )llvm_cbe_tmp__25)) * (*(double*)&FPConstant1)) + -5.000000e-001;
  llvm_cbe_sy_2e_0_2e_i = (((llvm_fcmp_olt(llvm_cbe_tmp__26, 0.000000e+000))) ? (0.000000e+000) : (llvm_cbe_tmp__26));
  llvm_cbe_tmp__27 = ((unsigned int )llvm_cbe_sy_2e_0_2e_i);
  llvm_cbe_tmp__28 = llvm_cbe_sy_2e_0_2e_i - (((double )(unsigned int )llvm_cbe_tmp__27));
  llvm_cbe_tmp__29 = 1.000000e+000 - llvm_cbe_tmp__28;
  llvm_cbe_tmp__30 = ((unsigned int )(((unsigned int )llvm_cbe_tmp__27) * ((unsigned int )640u)));
  llvm_cbe_tmp__31 = llvm_cbe_tmp__30 | 1u;
  llvm_cbe_tmp__32 = ((unsigned int )(((unsigned int )llvm_cbe_tmp__30) + ((unsigned int )640u)));
  llvm_cbe_tmp__33 = ((unsigned int )(((unsigned int )llvm_cbe_tmp__30) + ((unsigned int )641u)));
  llvm_cbe_tmp__6__PHI_TEMPORARY = 0u;   /* for PHI node */
  goto llvm_cbe_bb76_2e_i;

llvm_cbe_bb105_2e_i:
  llvm_cbe_tmp__24 = ((unsigned int )(((unsigned int )llvm_cbe_tmp__25) + ((unsigned int )1u)));
  if ((llvm_cbe_tmp__24 == 1080u)) {
    goto llvm_cbe_pix32_resize_2e_exit;
  } else {
    llvm_cbe_tmp__25__PHI_TEMPORARY = llvm_cbe_tmp__24;   /* for PHI node */
    goto llvm_cbe_bb104_2e_preheader_2e_i;
  }

  do {     /* Syntactic loop 'bb76.i' to make GCC happy */
llvm_cbe_bb76_2e_i:
  llvm_cbe_tmp__6 = llvm_cbe_tmp__6__PHI_TEMPORARY;
  llvm_cbe_scevgep_2e_i = (&test_buf2.array[((signed int )(((unsigned int )(((unsigned int )llvm_cbe_tmp__6) + ((unsigned int )llvm_cbe_tmp)))))]);
  llvm_cbe_tmp__7 = ((((double )(unsigned int )llvm_cbe_tmp__6)) * (*(double*)&FPConstant0)) + -5.000000e-001;
  llvm_cbe_sx_2e_0_2e_i = (((llvm_fcmp_olt(llvm_cbe_tmp__7, 0.000000e+000))) ? (0.000000e+000) : (llvm_cbe_tmp__7));
  llvm_cbe_tmp__8 = ((unsigned int )llvm_cbe_sx_2e_0_2e_i);
  llvm_cbe_tmp__9 = llvm_cbe_sx_2e_0_2e_i - (((double )(unsigned int )llvm_cbe_tmp__8));
  llvm_cbe_tmp__10 = 1.000000e+000 - llvm_cbe_tmp__9;
  llvm_cbe_tmp__11 = llvm_cbe_tmp__10 * llvm_cbe_tmp__29;
  llvm_cbe_tmp__12 = llvm_cbe_tmp__29 * llvm_cbe_tmp__9;
  llvm_cbe_tmp__13 = llvm_cbe_tmp__10 * llvm_cbe_tmp__28;
  llvm_cbe_tmp__14 = llvm_cbe_tmp__9 * llvm_cbe_tmp__28;
  llvm_cbe_tmp__15 = *((&test_buf.array[((signed int )(((unsigned int )(((unsigned int )llvm_cbe_tmp__8) + ((unsigned int )llvm_cbe_tmp__30)))))]));
  if ((((unsigned int )(((unsigned int )(((unsigned int )llvm_cbe_tmp__8) + ((unsigned int )1u))))) < ((unsigned int )640u))) {
    goto llvm_cbe_bb81_2e_i;
  } else {
    llvm_cbe_iftmp_2e_9_2e_0_2e_i__PHI_TEMPORARY = llvm_cbe_tmp__15;   /* for PHI node */
    goto llvm_cbe_bb83_2e_i;
  }

llvm_cbe_bb95_2e_i:
  llvm_cbe_iftmp_2e_11_2e_0_2e_i = llvm_cbe_iftmp_2e_11_2e_0_2e_i__PHI_TEMPORARY;
  llvm_cbe_tmp__19 = ((unsigned int )(((((((double )(signed int )((((unsigned int )(((unsigned int )llvm_cbe_tmp__15) >> ((unsigned int )16u)))) & 255u))) * llvm_cbe_tmp__11) + ((((double )(signed int )((((unsigned int )(((unsigned int )llvm_cbe_iftmp_2e_9_2e_0_2e_i) >> ((unsigned int )16u)))) & 255u))) * llvm_cbe_tmp__12)) + ((((double )(signed int )((((unsigned int )(((unsigned int )llvm_cbe_iftmp_2e_10_2e_0_2e_i) >> ((unsigned int )16u)))) & 255u))) * llvm_cbe_tmp__13)) + ((((double )(signed int )((((unsigned int )(((unsigned int )llvm_cbe_iftmp_2e_11_2e_0_2e_i) >> ((unsigned int )16u)))) & 255u))) * llvm_cbe_tmp__14)));
  llvm_cbe_tmp__20 = ((unsigned int )(((((((double )(signed int )((((unsigned int )(((unsigned int )llvm_cbe_tmp__15) >> ((unsigned int )8u)))) & 255u))) * llvm_cbe_tmp__11) + ((((double )(signed int )((((unsigned int )(((unsigned int )llvm_cbe_iftmp_2e_9_2e_0_2e_i) >> ((unsigned int )8u)))) & 255u))) * llvm_cbe_tmp__12)) + ((((double )(signed int )((((unsigned int )(((unsigned int )llvm_cbe_iftmp_2e_10_2e_0_2e_i) >> ((unsigned int )8u)))) & 255u))) * llvm_cbe_tmp__13)) + ((((double )(signed int )((((unsigned int )(((unsigned int )llvm_cbe_iftmp_2e_11_2e_0_2e_i) >> ((unsigned int )8u)))) & 255u))) * llvm_cbe_tmp__14)));
  llvm_cbe_tmp__21 = ((unsigned int )(((((((double )(signed int )(llvm_cbe_tmp__15 & 255u))) * llvm_cbe_tmp__11) + ((((double )(signed int )(llvm_cbe_iftmp_2e_9_2e_0_2e_i & 255u))) * llvm_cbe_tmp__12)) + ((((double )(signed int )(llvm_cbe_iftmp_2e_10_2e_0_2e_i & 255u))) * llvm_cbe_tmp__13)) + ((((double )(signed int )(llvm_cbe_iftmp_2e_11_2e_0_2e_i & 255u))) * llvm_cbe_tmp__14)));
  llvm_cbe_tmp__22 = ((unsigned int )(((((((double )(unsigned int )(((unsigned int )(((unsigned int )llvm_cbe_tmp__15) >> ((unsigned int )24u)))))) * llvm_cbe_tmp__11) + ((((double )(unsigned int )(((unsigned int )(((unsigned int )llvm_cbe_iftmp_2e_9_2e_0_2e_i) >> ((unsigned int )24u)))))) * llvm_cbe_tmp__12)) + ((((double )(unsigned int )(((unsigned int )(((unsigned int )llvm_cbe_iftmp_2e_10_2e_0_2e_i) >> ((unsigned int )24u)))))) * llvm_cbe_tmp__13)) + ((((double )(unsigned int )(((unsigned int )(((unsigned int )llvm_cbe_iftmp_2e_11_2e_0_2e_i) >> ((unsigned int )24u)))))) * llvm_cbe_tmp__14)));
  *llvm_cbe_scevgep_2e_i = (((((((((unsigned int )llvm_cbe_tmp__22) > ((unsigned int )254u))) ? (4278190080u) : ((llvm_cbe_tmp__22 << 24u)))) | ((((((unsigned int )llvm_cbe_tmp__21) > ((unsigned int )255u))) ? (255u) : (llvm_cbe_tmp__21)))) | ((((((unsigned int )llvm_cbe_tmp__19) > ((unsigned int )255u))) ? (16711680u) : ((llvm_cbe_tmp__19 << 16u))))) | ((((((unsigned int )llvm_cbe_tmp__20) > ((unsigned int )255u))) ? (65280u) : ((llvm_cbe_tmp__20 << 8u)))));
  llvm_cbe_tmp__23 = ((unsigned int )(((unsigned int )llvm_cbe_tmp__6) + ((unsigned int )1u)));
  if ((llvm_cbe_tmp__23 == 1920u)) {
    goto llvm_cbe_bb105_2e_i;
  } else {
    llvm_cbe_tmp__6__PHI_TEMPORARY = llvm_cbe_tmp__23;   /* for PHI node */
    goto llvm_cbe_bb76_2e_i;
  }

llvm_cbe_bb87_2e_i:
  llvm_cbe_tmp__18 = *((&test_buf.array[((signed int )(((unsigned int )(((unsigned int )llvm_cbe_tmp__33) + ((unsigned int )llvm_cbe_tmp__8)))))]));
  llvm_cbe_iftmp_2e_11_2e_0_2e_i__PHI_TEMPORARY = llvm_cbe_tmp__18;   /* for PHI node */
  goto llvm_cbe_bb95_2e_i;

llvm_cbe_bb86_2e_i:
  llvm_cbe_iftmp_2e_10_2e_0_2e_i = llvm_cbe_iftmp_2e_10_2e_0_2e_i__PHI_TEMPORARY;
  if (((((((unsigned int )(((unsigned int )(((unsigned int )llvm_cbe_tmp__8) + ((unsigned int )1u))))) < ((unsigned int )640u)) & (((unsigned int )(((unsigned int )(((unsigned int )llvm_cbe_tmp__27) + ((unsigned int )1u))))) < ((unsigned int )480u)))&1))) {
    goto llvm_cbe_bb87_2e_i;
  } else {
    goto llvm_cbe_bb88_2e_i;
  }

llvm_cbe_bb83_2e_i:
  llvm_cbe_iftmp_2e_9_2e_0_2e_i = llvm_cbe_iftmp_2e_9_2e_0_2e_i__PHI_TEMPORARY;
  if ((((unsigned int )(((unsigned int )(((unsigned int )llvm_cbe_tmp__27) + ((unsigned int )1u))))) < ((unsigned int )480u))) {
    goto llvm_cbe_bb84_2e_i;
  } else {
    llvm_cbe_iftmp_2e_10_2e_0_2e_i__PHI_TEMPORARY = llvm_cbe_tmp__15;   /* for PHI node */
    goto llvm_cbe_bb86_2e_i;
  }

llvm_cbe_bb81_2e_i:
  llvm_cbe_tmp__16 = *((&test_buf.array[((signed int )(((unsigned int )(((unsigned int )llvm_cbe_tmp__8) + ((unsigned int )llvm_cbe_tmp__31)))))]));
  llvm_cbe_iftmp_2e_9_2e_0_2e_i__PHI_TEMPORARY = llvm_cbe_tmp__16;   /* for PHI node */
  goto llvm_cbe_bb83_2e_i;

llvm_cbe_bb84_2e_i:
  llvm_cbe_tmp__17 = *((&test_buf.array[((signed int )(((unsigned int )(((unsigned int )llvm_cbe_tmp__32) + ((unsigned int )llvm_cbe_tmp__8)))))]));
  llvm_cbe_iftmp_2e_10_2e_0_2e_i__PHI_TEMPORARY = llvm_cbe_tmp__17;   /* for PHI node */
  goto llvm_cbe_bb86_2e_i;

llvm_cbe_bb88_2e_i:
  if ((((unsigned int )(((unsigned int )(((unsigned int )llvm_cbe_tmp__8) + ((unsigned int )1u))))) < ((unsigned int )640u))) {
    llvm_cbe_iftmp_2e_11_2e_0_2e_i__PHI_TEMPORARY = llvm_cbe_iftmp_2e_9_2e_0_2e_i;   /* for PHI node */
    goto llvm_cbe_bb95_2e_i;
  } else {
    goto llvm_cbe_bb89_2e_i;
  }

llvm_cbe_bb89_2e_i:
  llvm_cbe_iftmp_2e_13_2e_0_2e_i = (((((unsigned int )(((unsigned int )(((unsigned int )llvm_cbe_tmp__27) + ((unsigned int )1u))))) < ((unsigned int )480u))) ? (llvm_cbe_iftmp_2e_10_2e_0_2e_i) : (llvm_cbe_tmp__15));
  llvm_cbe_iftmp_2e_11_2e_0_2e_i__PHI_TEMPORARY = llvm_cbe_iftmp_2e_13_2e_0_2e_i;   /* for PHI node */
  goto llvm_cbe_bb95_2e_i;

  } while (1); /* end of syntactic loop 'bb76.i' */
  } while (1); /* end of syntactic loop 'bb104.preheader.i' */
llvm_cbe_pix32_resize_2e_exit:
  return;
}


unsigned int main(unsigned int llvm_cbe_argc, unsigned char **llvm_cbe_argv) {
  struct l_unnamed12 llvm_cbe_elaped_2e_i;    /* Address-exposed local */
  struct l_unnamed13 llvm_cbe_nm_2e_i;    /* Address-exposed local */
  unsigned int llvm_cbe_tmp__34;
  unsigned char *llvm_cbe_tmp__35;
  unsigned char llvm_cbe_tmp__36;
  unsigned char llvm_cbe_tmp__37;
  unsigned int llvm_cbe_tmp__38;
  unsigned char *llvm_cbe_tmp__39;
  unsigned int llvm_cbe_tmp__40;
  unsigned char *llvm_cbe_name_2e_0;
  unsigned char *llvm_cbe_name_2e_0__PHI_TEMPORARY;
  unsigned int llvm_cbe_flags_2e_0;
  unsigned int llvm_cbe_flags_2e_0__PHI_TEMPORARY;
  unsigned int llvm_cbe_count_2e_0;
  unsigned int llvm_cbe_count_2e_0__PHI_TEMPORARY;
  unsigned int llvm_cbe_phitmp;
  unsigned int llvm_cbe_indvar;
  unsigned int llvm_cbe_indvar__PHI_TEMPORARY;
  unsigned char *llvm_cbe_name_2e_1;
  unsigned char *llvm_cbe_name_2e_1__PHI_TEMPORARY;
  unsigned int llvm_cbe_flags_2e_1;
  unsigned int llvm_cbe_flags_2e_1__PHI_TEMPORARY;
  unsigned int llvm_cbe_count_2e_1;
  unsigned int llvm_cbe_count_2e_1__PHI_TEMPORARY;
  unsigned char *llvm_cbe_tmp__41;
  unsigned char *llvm_cbe_tmp__42;
  unsigned int llvm_cbe_tmp__43;
  unsigned int llvm_cbe_XorShiftRand_seed__2e_1_2e_tmp_2e_0_2e_i_2e_i;
  unsigned int llvm_cbe_XorShiftRand_seed__2e_1_2e_tmp_2e_0_2e_i_2e_i__PHI_TEMPORARY;
  unsigned int llvm_cbe_XorShiftRand_seed__2e_0_2e_tmp_2e_0_2e_i_2e_i;
  unsigned int llvm_cbe_XorShiftRand_seed__2e_0_2e_tmp_2e_0_2e_i_2e_i__PHI_TEMPORARY;
  unsigned int llvm_cbe_x_2e_06_2e_i_2e_i;
  unsigned int llvm_cbe_x_2e_06_2e_i_2e_i__PHI_TEMPORARY;
  unsigned int llvm_cbe_tmp__44;
  unsigned int llvm_cbe_tmp__45;
  unsigned int llvm_cbe_tmp__46;
  unsigned int llvm_cbe_tmp__47;
  unsigned int llvm_cbe_XorShiftRand_seed__2e_1_2e_tmp_2e_1_2e_i_2e_i;
  unsigned int llvm_cbe_XorShiftRand_seed__2e_1_2e_tmp_2e_1_2e_i_2e_i__PHI_TEMPORARY;
  unsigned int llvm_cbe_XorShiftRand_seed__2e_0_2e_tmp_2e_1_2e_i_2e_i;
  unsigned int llvm_cbe_XorShiftRand_seed__2e_0_2e_tmp_2e_1_2e_i_2e_i__PHI_TEMPORARY;
  unsigned int llvm_cbe_y_2e_07_2e_i_2e_i;
  unsigned int llvm_cbe_y_2e_07_2e_i_2e_i__PHI_TEMPORARY;
  unsigned int llvm_cbe_tmp;
  unsigned char *llvm_cbe_iftmp_2e_16_2e_0_2e_i;
  unsigned int llvm_cbe_tmp__48;
  unsigned int llvm_cbe_tmp__49;
  unsigned int llvm_cbe_j_2e_02_2e_i_2e_i;
  unsigned int llvm_cbe_j_2e_02_2e_i_2e_i__PHI_TEMPORARY;
  unsigned int llvm_cbe_tmp__50;
  unsigned int llvm_cbe_tmp__51;
  double llvm_cbe_tmp__52;
  unsigned int llvm_cbe_tmp__53;
  unsigned int llvm_cbe_test_dmy_counter_2e_promoted_2e_i_2e_i;
  unsigned int llvm_cbe_test_dmy_counter_2e_tmp_2e_0_2e_i_2e_i;
  unsigned int llvm_cbe_test_dmy_counter_2e_tmp_2e_0_2e_i_2e_i__PHI_TEMPORARY;
  unsigned int llvm_cbe_j_2e_11_2e_i_2e_i;
  unsigned int llvm_cbe_j_2e_11_2e_i_2e_i__PHI_TEMPORARY;
  unsigned int llvm_cbe_tmp__54;
  unsigned int llvm_cbe_tmp__55;
  unsigned int llvm_cbe_tmp__56;
  unsigned int llvm_cbe_j_2e_018_2e_i;
  unsigned int llvm_cbe_j_2e_018_2e_i__PHI_TEMPORARY;
  unsigned char *llvm_cbe_tmp__57;
  unsigned int llvm_cbe_tmp__58;
  double llvm_cbe_tmp__59;
  double llvm_cbe_tmp__60;
  unsigned int llvm_cbe_tmp__61;
  unsigned int llvm_cbe_tmp__62;
  unsigned int llvm_cbe_tmp__63;
  unsigned int llvm_cbe_tmp__64;
  unsigned int llvm_cbe__2e_pre_2e_i;
  unsigned int llvm_cbe_tmp__65;

  CODE_FOR_MAIN();
  if ((((signed int )llvm_cbe_argc) > ((signed int )1u))) {
    llvm_cbe_indvar__PHI_TEMPORARY = 1u;   /* for PHI node */
    llvm_cbe_name_2e_1__PHI_TEMPORARY = ((unsigned char *)/*NULL*/0);   /* for PHI node */
    llvm_cbe_flags_2e_1__PHI_TEMPORARY = 0u;   /* for PHI node */
    llvm_cbe_count_2e_1__PHI_TEMPORARY = 1u;   /* for PHI node */
    goto llvm_cbe_bb12;
  } else {
    goto llvm_cbe_bb;
  }

llvm_cbe_bb:
  llvm_cbe_tmp__34 = puts(((&_2E_str.array[((signed int )0u)])));
  return 1u;
llvm_cbe_bb10:
  llvm_cbe_tmp__40 = puts(((&_2E_str.array[((signed int )0u)])));
  return 1u;
  do {     /* Syntactic loop 'bb12' to make GCC happy */
llvm_cbe_bb12:
  llvm_cbe_indvar = llvm_cbe_indvar__PHI_TEMPORARY;
  llvm_cbe_name_2e_1 = llvm_cbe_name_2e_1__PHI_TEMPORARY;
  llvm_cbe_flags_2e_1 = llvm_cbe_flags_2e_1__PHI_TEMPORARY;
  llvm_cbe_count_2e_1 = llvm_cbe_count_2e_1__PHI_TEMPORARY;
  if ((((signed int )llvm_cbe_indvar) < ((signed int )llvm_cbe_argc))) {
    goto llvm_cbe_bb2;
  } else {
    goto llvm_cbe_bb13;
  }

llvm_cbe_bb11:
  llvm_cbe_name_2e_0 = llvm_cbe_name_2e_0__PHI_TEMPORARY;
  llvm_cbe_flags_2e_0 = llvm_cbe_flags_2e_0__PHI_TEMPORARY;
  llvm_cbe_count_2e_0 = llvm_cbe_count_2e_0__PHI_TEMPORARY;
  llvm_cbe_phitmp = ((unsigned int )(((unsigned int )llvm_cbe_indvar) + ((unsigned int )1u)));
  llvm_cbe_indvar__PHI_TEMPORARY = llvm_cbe_phitmp;   /* for PHI node */
  llvm_cbe_name_2e_1__PHI_TEMPORARY = llvm_cbe_name_2e_0;   /* for PHI node */
  llvm_cbe_flags_2e_1__PHI_TEMPORARY = llvm_cbe_flags_2e_0;   /* for PHI node */
  llvm_cbe_count_2e_1__PHI_TEMPORARY = llvm_cbe_count_2e_0;   /* for PHI node */
  goto llvm_cbe_bb12;

llvm_cbe_bb2:
  llvm_cbe_tmp__35 = *((&llvm_cbe_argv[((signed int )llvm_cbe_indvar)]));
  llvm_cbe_tmp__36 = *llvm_cbe_tmp__35;
  if ((llvm_cbe_tmp__36 == ((unsigned char )45))) {
    goto llvm_cbe_bb3;
  } else {
    llvm_cbe_name_2e_0__PHI_TEMPORARY = llvm_cbe_name_2e_1;   /* for PHI node */
    llvm_cbe_flags_2e_0__PHI_TEMPORARY = llvm_cbe_flags_2e_1;   /* for PHI node */
    llvm_cbe_count_2e_0__PHI_TEMPORARY = llvm_cbe_count_2e_1;   /* for PHI node */
    goto llvm_cbe_bb11;
  }

llvm_cbe_bb3:
  llvm_cbe_tmp__37 = *((&llvm_cbe_tmp__35[((signed int )1u)]));
  switch (llvm_cbe_tmp__37) {
  default:
    goto llvm_cbe_bb10;
;
  case ((unsigned char )118):
    llvm_cbe_name_2e_0__PHI_TEMPORARY = llvm_cbe_name_2e_1;   /* for PHI node */
    llvm_cbe_flags_2e_0__PHI_TEMPORARY = 1u;   /* for PHI node */
    llvm_cbe_count_2e_0__PHI_TEMPORARY = llvm_cbe_count_2e_1;   /* for PHI node */
    goto llvm_cbe_bb11;
  case ((unsigned char )99):
    goto llvm_cbe_bb6;
    break;
  case ((unsigned char )116):
    goto llvm_cbe_bb9;
  }
llvm_cbe_bb6:
  llvm_cbe_tmp__38 = strtol(((&llvm_cbe_tmp__35[((signed int )2u)])), 0u, 0u);
  if ((llvm_cbe_tmp__38 == 0u)) {
    goto llvm_cbe_bb7;
  } else {
    llvm_cbe_name_2e_0__PHI_TEMPORARY = llvm_cbe_name_2e_1;   /* for PHI node */
    llvm_cbe_flags_2e_0__PHI_TEMPORARY = llvm_cbe_flags_2e_1;   /* for PHI node */
    llvm_cbe_count_2e_0__PHI_TEMPORARY = llvm_cbe_tmp__38;   /* for PHI node */
    goto llvm_cbe_bb11;
  }

llvm_cbe_bb7:
  llvm_cbe_name_2e_0__PHI_TEMPORARY = llvm_cbe_name_2e_1;   /* for PHI node */
  llvm_cbe_flags_2e_0__PHI_TEMPORARY = llvm_cbe_flags_2e_1;   /* for PHI node */
  llvm_cbe_count_2e_0__PHI_TEMPORARY = 1u;   /* for PHI node */
  goto llvm_cbe_bb11;

llvm_cbe_bb9:
  llvm_cbe_tmp__39 = (&llvm_cbe_tmp__35[((signed int )2u)]);
  llvm_cbe_name_2e_0__PHI_TEMPORARY = llvm_cbe_tmp__39;   /* for PHI node */
  llvm_cbe_flags_2e_0__PHI_TEMPORARY = llvm_cbe_flags_2e_1;   /* for PHI node */
  llvm_cbe_count_2e_0__PHI_TEMPORARY = llvm_cbe_count_2e_1;   /* for PHI node */
  goto llvm_cbe_bb11;

  } while (1); /* end of syntactic loop 'bb12' */
llvm_cbe_bb13:
  llvm_cbe_tmp__41 = memset((((unsigned char *)(&llvm_cbe_nm_2e_i))), 0u, 256u);
  llvm_cbe_tmp__42 = memset((((unsigned char *)(&llvm_cbe_elaped_2e_i))), 0u, 512u);
  if ((llvm_cbe_name_2e_1 == ((unsigned char *)/*NULL*/0))) {
    goto llvm_cbe_bb_2e_i;
  } else {
    goto llvm_cbe_bb3_2e_i;
  }

llvm_cbe_bb_2e_i:
  llvm_cbe_tmp__43 = printf(((&_2E_str3.array[((signed int )0u)])), llvm_cbe_count_2e_1);
  goto llvm_cbe_bb3_2e_i;

llvm_cbe_bb3_2e_i:
  *(&XorShiftRand_seed__2E_0) = 1u;
  *(&XorShiftRand_seed__2E_1) = 1812433255u;
  llvm_cbe_XorShiftRand_seed__2e_1_2e_tmp_2e_1_2e_i_2e_i__PHI_TEMPORARY = 1812433255u;   /* for PHI node */
  llvm_cbe_XorShiftRand_seed__2e_0_2e_tmp_2e_1_2e_i_2e_i__PHI_TEMPORARY = 1u;   /* for PHI node */
  llvm_cbe_y_2e_07_2e_i_2e_i__PHI_TEMPORARY = 0u;   /* for PHI node */
  goto llvm_cbe_bb2_2e_preheader_2e_i_2e_i;

  do {     /* Syntactic loop 'bb2.preheader.i.i' to make GCC happy */
llvm_cbe_bb2_2e_preheader_2e_i_2e_i:
  llvm_cbe_XorShiftRand_seed__2e_1_2e_tmp_2e_1_2e_i_2e_i = llvm_cbe_XorShiftRand_seed__2e_1_2e_tmp_2e_1_2e_i_2e_i__PHI_TEMPORARY;
  llvm_cbe_XorShiftRand_seed__2e_0_2e_tmp_2e_1_2e_i_2e_i = llvm_cbe_XorShiftRand_seed__2e_0_2e_tmp_2e_1_2e_i_2e_i__PHI_TEMPORARY;
  llvm_cbe_y_2e_07_2e_i_2e_i = llvm_cbe_y_2e_07_2e_i_2e_i__PHI_TEMPORARY;
  llvm_cbe_tmp = ((unsigned int )(((unsigned int )llvm_cbe_y_2e_07_2e_i_2e_i) * ((unsigned int )640u)));
  llvm_cbe_XorShiftRand_seed__2e_1_2e_tmp_2e_0_2e_i_2e_i__PHI_TEMPORARY = llvm_cbe_XorShiftRand_seed__2e_1_2e_tmp_2e_1_2e_i_2e_i;   /* for PHI node */
  llvm_cbe_XorShiftRand_seed__2e_0_2e_tmp_2e_0_2e_i_2e_i__PHI_TEMPORARY = llvm_cbe_XorShiftRand_seed__2e_0_2e_tmp_2e_1_2e_i_2e_i;   /* for PHI node */
  llvm_cbe_x_2e_06_2e_i_2e_i__PHI_TEMPORARY = 0u;   /* for PHI node */
  goto llvm_cbe_bb1_2e_i_2e_i;

llvm_cbe_bb3_2e_i_2e_i:
  llvm_cbe_tmp__47 = ((unsigned int )(((unsigned int )llvm_cbe_y_2e_07_2e_i_2e_i) + ((unsigned int )1u)));
  if ((llvm_cbe_tmp__47 == 480u)) {
    goto llvm_cbe_test_init1_2e_exit_2e_i;
  } else {
    llvm_cbe_XorShiftRand_seed__2e_1_2e_tmp_2e_1_2e_i_2e_i__PHI_TEMPORARY = llvm_cbe_tmp__45;   /* for PHI node */
    llvm_cbe_XorShiftRand_seed__2e_0_2e_tmp_2e_1_2e_i_2e_i__PHI_TEMPORARY = llvm_cbe_XorShiftRand_seed__2e_1_2e_tmp_2e_0_2e_i_2e_i;   /* for PHI node */
    llvm_cbe_y_2e_07_2e_i_2e_i__PHI_TEMPORARY = llvm_cbe_tmp__47;   /* for PHI node */
    goto llvm_cbe_bb2_2e_preheader_2e_i_2e_i;
  }

  do {     /* Syntactic loop 'bb1.i.i' to make GCC happy */
llvm_cbe_bb1_2e_i_2e_i:
  llvm_cbe_XorShiftRand_seed__2e_1_2e_tmp_2e_0_2e_i_2e_i = llvm_cbe_XorShiftRand_seed__2e_1_2e_tmp_2e_0_2e_i_2e_i__PHI_TEMPORARY;
  llvm_cbe_XorShiftRand_seed__2e_0_2e_tmp_2e_0_2e_i_2e_i = llvm_cbe_XorShiftRand_seed__2e_0_2e_tmp_2e_0_2e_i_2e_i__PHI_TEMPORARY;
  llvm_cbe_x_2e_06_2e_i_2e_i = llvm_cbe_x_2e_06_2e_i_2e_i__PHI_TEMPORARY;
  llvm_cbe_tmp__44 = (llvm_cbe_XorShiftRand_seed__2e_0_2e_tmp_2e_0_2e_i_2e_i << 10u) ^ llvm_cbe_XorShiftRand_seed__2e_0_2e_tmp_2e_0_2e_i_2e_i;
  llvm_cbe_tmp__45 = (((((unsigned int )(((unsigned int )llvm_cbe_XorShiftRand_seed__2e_1_2e_tmp_2e_0_2e_i_2e_i) >> ((unsigned int )10u)))) ^ llvm_cbe_XorShiftRand_seed__2e_1_2e_tmp_2e_0_2e_i_2e_i) ^ llvm_cbe_tmp__44) ^ (((unsigned int )(((unsigned int )llvm_cbe_tmp__44) >> ((unsigned int )13u))));
  *((&test_buf.array[((signed int )(((unsigned int )(((unsigned int )llvm_cbe_x_2e_06_2e_i_2e_i) + ((unsigned int )llvm_cbe_tmp)))))])) = llvm_cbe_tmp__45;
  llvm_cbe_tmp__46 = ((unsigned int )(((unsigned int )llvm_cbe_x_2e_06_2e_i_2e_i) + ((unsigned int )1u)));
  if ((llvm_cbe_tmp__46 == 640u)) {
    goto llvm_cbe_bb3_2e_i_2e_i;
  } else {
    llvm_cbe_XorShiftRand_seed__2e_1_2e_tmp_2e_0_2e_i_2e_i__PHI_TEMPORARY = llvm_cbe_tmp__45;   /* for PHI node */
    llvm_cbe_XorShiftRand_seed__2e_0_2e_tmp_2e_0_2e_i_2e_i__PHI_TEMPORARY = llvm_cbe_XorShiftRand_seed__2e_1_2e_tmp_2e_0_2e_i_2e_i;   /* for PHI node */
    llvm_cbe_x_2e_06_2e_i_2e_i__PHI_TEMPORARY = llvm_cbe_tmp__46;   /* for PHI node */
    goto llvm_cbe_bb1_2e_i_2e_i;
  }

  } while (1); /* end of syntactic loop 'bb1.i.i' */
  } while (1); /* end of syntactic loop 'bb2.preheader.i.i' */
llvm_cbe_test_init1_2e_exit_2e_i:
  llvm_cbe_iftmp_2e_16_2e_0_2e_i = (((llvm_cbe_name_2e_1 == ((unsigned char *)/*NULL*/0))) ? (((&_2E_str4.array[((signed int )0u)]))) : (llvm_cbe_name_2e_1));
  *(&XorShiftRand_seed__2E_0) = llvm_cbe_XorShiftRand_seed__2e_1_2e_tmp_2e_0_2e_i_2e_i;
  *(&XorShiftRand_seed__2E_1) = llvm_cbe_tmp__45;
  *((&llvm_cbe_nm_2e_i.array[((signed int )0u)])) = llvm_cbe_iftmp_2e_16_2e_0_2e_i;
  if (((llvm_cbe_flags_2e_1 & 1u) == 0u)) {
    goto llvm_cbe_bb1_2e_i15_2e_i;
  } else {
    goto llvm_cbe_bb_2e_i_2e_i;
  }

llvm_cbe_bb_2e_i_2e_i:
  llvm_cbe_tmp__48 = printf(((&_2E_str1.array[((signed int )0u)])), llvm_cbe_iftmp_2e_16_2e_0_2e_i);
  goto llvm_cbe_bb1_2e_i15_2e_i;

llvm_cbe_bb1_2e_i15_2e_i:
  llvm_cbe_tmp__49 = clock();
  if ((llvm_cbe_count_2e_1 == 0u)) {
    goto llvm_cbe_bb4_2e_i_2e_i;
  } else {
    llvm_cbe_j_2e_02_2e_i_2e_i__PHI_TEMPORARY = 0u;   /* for PHI node */
    goto llvm_cbe_bb2_2e_i_2e_i;
  }

  do {     /* Syntactic loop 'bb2.i.i' to make GCC happy */
llvm_cbe_bb2_2e_i_2e_i:
  llvm_cbe_j_2e_02_2e_i_2e_i = llvm_cbe_j_2e_02_2e_i_2e_i__PHI_TEMPORARY;
  test_1();
  llvm_cbe_tmp__50 = ((unsigned int )(((unsigned int )llvm_cbe_j_2e_02_2e_i_2e_i) + ((unsigned int )1u)));
  if ((llvm_cbe_tmp__50 == llvm_cbe_count_2e_1)) {
    goto llvm_cbe_bb4_2e_i_2e_i;
  } else {
    llvm_cbe_j_2e_02_2e_i_2e_i__PHI_TEMPORARY = llvm_cbe_tmp__50;   /* for PHI node */
    goto llvm_cbe_bb2_2e_i_2e_i;
  }

  } while (1); /* end of syntactic loop 'bb2.i.i' */
llvm_cbe_bb4_2e_i_2e_i:
  llvm_cbe_tmp__51 = clock();
  llvm_cbe_tmp__52 = (((double )(signed int )(((unsigned int )(((unsigned int )llvm_cbe_tmp__51) - ((unsigned int )llvm_cbe_tmp__49)))))) / (((double )(unsigned int )(((unsigned int )(((unsigned int )llvm_cbe_count_2e_1) * ((unsigned int )1000u))))));
  if (((llvm_cbe_flags_2e_1 & 1u) == 0u)) {
    goto llvm_cbe_bb8_2e_preheader_2e_i_2e_i;
  } else {
    goto llvm_cbe_bb5_2e_i_2e_i;
  }

llvm_cbe_bb5_2e_i_2e_i:
  llvm_cbe_tmp__53 = printf(((&_2E_str2.array[((signed int )0u)])), llvm_cbe_iftmp_2e_16_2e_0_2e_i, (llvm_cbe_tmp__52 * 1.000000e+006));
  goto llvm_cbe_bb8_2e_preheader_2e_i_2e_i;

llvm_cbe_bb8_2e_preheader_2e_i_2e_i:
  llvm_cbe_test_dmy_counter_2e_promoted_2e_i_2e_i = *(&test_dmy_counter);
  llvm_cbe_test_dmy_counter_2e_tmp_2e_0_2e_i_2e_i__PHI_TEMPORARY = llvm_cbe_test_dmy_counter_2e_promoted_2e_i_2e_i;   /* for PHI node */
  llvm_cbe_j_2e_11_2e_i_2e_i__PHI_TEMPORARY = 0u;   /* for PHI node */
  goto llvm_cbe_bb7_2e_i_2e_i;

  do {     /* Syntactic loop 'bb7.i.i' to make GCC happy */
llvm_cbe_bb7_2e_i_2e_i:
  llvm_cbe_test_dmy_counter_2e_tmp_2e_0_2e_i_2e_i = llvm_cbe_test_dmy_counter_2e_tmp_2e_0_2e_i_2e_i__PHI_TEMPORARY;
  llvm_cbe_j_2e_11_2e_i_2e_i = llvm_cbe_j_2e_11_2e_i_2e_i__PHI_TEMPORARY;
  llvm_cbe_tmp__54 = *((&test_buf2.array[((signed int )llvm_cbe_j_2e_11_2e_i_2e_i)]));
  llvm_cbe_tmp__55 = ((unsigned int )(((unsigned int )llvm_cbe_tmp__54) + ((unsigned int )llvm_cbe_test_dmy_counter_2e_tmp_2e_0_2e_i_2e_i)));
  llvm_cbe_tmp__56 = ((unsigned int )(((unsigned int )llvm_cbe_j_2e_11_2e_i_2e_i) + ((unsigned int )1u)));
  if ((llvm_cbe_tmp__56 == 2073600u)) {
    goto llvm_cbe_benchmark_2e_exit_2e_i;
  } else {
    llvm_cbe_test_dmy_counter_2e_tmp_2e_0_2e_i_2e_i__PHI_TEMPORARY = llvm_cbe_tmp__55;   /* for PHI node */
    llvm_cbe_j_2e_11_2e_i_2e_i__PHI_TEMPORARY = llvm_cbe_tmp__56;   /* for PHI node */
    goto llvm_cbe_bb7_2e_i_2e_i;
  }

  } while (1); /* end of syntactic loop 'bb7.i.i' */
llvm_cbe_benchmark_2e_exit_2e_i:
  *(&test_dmy_counter) = llvm_cbe_tmp__55;
  *((&llvm_cbe_elaped_2e_i.array[((signed int )0u)])) = llvm_cbe_tmp__52;
  llvm_cbe_j_2e_018_2e_i__PHI_TEMPORARY = 0u;   /* for PHI node */
  goto llvm_cbe_bb7_2e_i;

  do {     /* Syntactic loop 'bb7.i' to make GCC happy */
llvm_cbe_bb7_2e_i:
  llvm_cbe_j_2e_018_2e_i = llvm_cbe_j_2e_018_2e_i__PHI_TEMPORARY;
  llvm_cbe_tmp__57 = *((&llvm_cbe_nm_2e_i.array[((signed int )llvm_cbe_j_2e_018_2e_i)]));
  if ((llvm_cbe_tmp__57 == ((unsigned char *)/*NULL*/0))) {
    goto llvm_cbe_bb12_2e_i;
  } else {
    goto llvm_cbe_bb8_2e_i;
  }

llvm_cbe_bb12_2e_i:
  llvm_cbe_tmp__64 = ((unsigned int )(((unsigned int )llvm_cbe_j_2e_018_2e_i) + ((unsigned int )1u)));
  if ((llvm_cbe_tmp__64 == 64u)) {
    goto llvm_cbe_test_all_2e_exit;
  } else {
    llvm_cbe_j_2e_018_2e_i__PHI_TEMPORARY = llvm_cbe_tmp__64;   /* for PHI node */
    goto llvm_cbe_bb7_2e_i;
  }

llvm_cbe_bb11_2e_i:
  llvm_cbe_tmp__63 = putchar(10u);
  goto llvm_cbe_bb12_2e_i;

llvm_cbe_bb9_2e_i:
  llvm_cbe_tmp__61 = printf(((&_2E_str6.array[((signed int )0u)])), llvm_cbe_tmp__60);
  goto llvm_cbe_bb11_2e_i;

llvm_cbe_bb8_2e_i:
  llvm_cbe_tmp__58 = printf(((&_2E_str5.array[((signed int )0u)])), llvm_cbe_tmp__57);
  llvm_cbe_tmp__59 = *((&llvm_cbe_elaped_2e_i.array[((signed int )llvm_cbe_j_2e_018_2e_i)]));
  llvm_cbe_tmp__60 = llvm_cbe_tmp__59 * 1.000000e+003;
  if ((llvm_fcmp_ogt(llvm_cbe_tmp__60, 0.000000e+000))) {
    goto llvm_cbe_bb9_2e_i;
  } else {
    goto llvm_cbe_bb10_2e_i;
  }

llvm_cbe_bb10_2e_i:
  llvm_cbe_tmp__62 = printf(((&_2E_str7.array[((signed int )0u)])), ((&_2E_str8.array[((signed int )0u)])));
  goto llvm_cbe_bb11_2e_i;

  } while (1); /* end of syntactic loop 'bb7.i' */
llvm_cbe_test_all_2e_exit:
  llvm_cbe__2e_pre_2e_i = *(&test_dmy_counter);
  llvm_cbe_tmp__65 = printf(((&_2E_str9.array[((signed int )0u)])), llvm_cbe__2e_pre_2e_i);
  return 0u;
}

